ContextualSerializer
Date: 2016-12-04

com.fasterxml.jackson.databind.ser

## Interface ContextualSerializer

- All Known Implementing Classes:
    ArraySerializerBase, AsArraySerializerBase, AtomicReferenceSerializer, BeanAsArraySerializer, BeanSerializer, BeanSerializerBase, CalendarSerializer, CollectionSerializer, CoreXMLSerializers.XMLGregorianCalendarSerializer, DateSerializer, DateTimeSerializerBase, EnumSerializer, EnumSetSerializer, IndexedListSerializer, IndexedStringListSerializer, IterableSerializer, IteratorSerializer, JsonValueSerializer, MapEntrySerializer, MapSerializer, NumberSerializers.Base, NumberSerializers.DoubleSerializer, NumberSerializers.FloatSerializer, NumberSerializers.IntegerSerializer, NumberSerializers.IntLikeSerializer, NumberSerializers.LongSerializer, NumberSerializers.ShortSerializer, ObjectArraySerializer, ReferenceTypeSerializer, SqlDateSerializer, StaticListSerializerBase, StdArraySerializers.BooleanArraySerializer, StdArraySerializers.DoubleArraySerializer, StdArraySerializers.FloatArraySerializer, StdArraySerializers.IntArraySerializer, StdArraySerializers.LongArraySerializer, StdArraySerializers.ShortArraySerializer, StdArraySerializers.TypedPrimitiveArraySerializer, StdDelegatingSerializer, StringArraySerializer, StringCollectionSerializer, UnwrappingBeanSerializer

      public interface ContextualSerializer

  Add-on interface that `JsonSerializer`s can implement to get a callback that can be used to create contextual instances of serializer to use for handling properties of supported type. This can be useful for serializers that can be configured by annotations, or should otherwise have differing behavior depending on what kind of property is being serialized.

  Note that in cases where serializer needs both contextualization and resolution -- that is, implements both this interface and `ResolvableSerializer` -- resolution via `ResolvableSerializer` occurs first, and contextual resolution (via this interface) later on.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `JsonSerializer<?>` | `createContextual(SerializerProvider prov, BeanProperty property)` Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property.

- - ### Method Detail

    - #### createContextual

          JsonSerializer<?> createContextual(SerializerProvider prov,
                                           BeanProperty property)
                                             throws JsonMappingException

      Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.
      Parameters:
        `prov` - Serializer provider to use for accessing config, other serializers
        `property` - Method or field that represents the property (and is used to access value to serialize). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' serializer as is)
      Returns:
        Serializer to use for serializing values of specified property; may be this instance or a new instance.
      Throws:
        `JsonMappingException`